/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   Henk-Johan van Rantwijk <bugs4hj@netscape.net> (Original Author)
 *   David Perry <d.perry@utoronto.ca>
 *   Neil Pryde <NeilPryde92651@netscape.net> (well I'm just HJ's typewriter)
 * 
 */

////////////////////////////////////////////////////////////////////////////////
// this function initializes the preferences for MultiZilla
////////////////////////////////////////////////////////////////////////////////
function initPreferences()
{
  // moved to initTabPosition() in multiviewsInit.js
  // mvPrefs.TopTabs = readMyPref( "multizilla.tabs.ontop", "bool", true );
  mvPrefs.PrefWarning       = readMyPref( "multizilla.display.prefwarning", "bool", true );
  mvPrefs.NewPreferred      = readMyPref( "multizilla.new.preferred", "int", 3 );
  mvPrefs.PreferredLocation = readMyPref( "multizilla.preferred.location", "string", "http://multizilla.mozdev.org/index.html" );
  mvPrefs.MaxStickyLen      = readMyPref( "multizilla.sticky.maxlen", "int", mvGlobal.DefLabelLength );
  mvPrefs.TitleSticky       = readMyPref( "multizilla.sticky.title", "bool", true );
  mvPrefs.AutohideTabs      = readMyPref( "multizilla.tabs.autohide", "bool", false );
  mvPrefs.MMClickNewTab     = readMyPref( "multizilla.mouse-middle-click.newtab", "bool", true );
  mvPrefs.PreventDouble     = readMyPref( "multizilla.prevent.double", "bool", true );
  mvPrefs.BMarksNewTab      = readMyPref( "multizilla.bookmarks.newtab", "bool", false );
  mvPrefs.PToolbarNewTab    = readMyPref( "multizilla.personal-toolbar.newtab", "bool", false );
  mvPrefs.DevTooltips       = readMyPref( "multizilla.developer.tooltips", "bool", false );
  mvPrefs.SecretGarden      = readMyPref( "multizilla.secret.garden", "bool", false );
  mvPrefs.StatusLeds        = readMyPref( "multizilla.status-leds.enabled", "bool", true );
  mvPrefs.ForceHomepage     = readMyPref( "multizilla.load.homepage", "bool", false );
  mvPrefs.ToolbarIcons      = readMyPref( "multizilla.toolbar.icons", "bool", true );
  mvPrefs.MMClickClose      = readMyPref( "multizilla.mouse-middle-click.close", "bool", true );
  mvPrefs.URLbarNewTab      = readMyPref( "multizilla.urlbar.newtab", "bool", true );
  mvPrefs.ConfirmQuit       = readMyPref( "multizilla.confirm.quit", "int", 3 );
  mvPrefs.LoadInBackground  = readMyPref( "multizilla.load-in.background", "bool", false );
  mvPrefs.TabStartUpGroup   = readMyPref( "multizilla.startup.group", "string", "" );
  mvPrefs.SlaveTab          = readMyPref( "multizilla.mouse-middle-click.slavetab", "bool", false );
  mvPrefs.hideOnOverflow    = readMyPref( "multizilla.hidetab.onoverflow", "bool", false );
  mvPrefs.removeOnOverflow  = readMyPref( "multizilla.removetab.onoverflow", "bool", false );

  if ( ( mvPrefs.MaxStickyLen < mvPrefs.MinStickyLen ) || ( mvPrefs.MaxStickyLen > 50 ) )
    mvPrefs.MaxStickyLen = mvGlobal.DefLabelLength;

  /* if ( ( mvPrefs.AutohideTabs ) || ( mvPrefs.SecretGarden ) )
    toggleTabs(); */

  if ( mvPrefs.newPrefsAdded && !mvPrefs.PrefWarning ) {
    alert( 'MultiZilla has just updated your copy of: prefs.js\n(' + mvPrefs.newPrefsAdded + ' preference settings are automatically added)');
		mvPrefs.newPrefsAdded = 0;
  }
	setIdentifier();
}
////////////////////////////////////////////////////////////////////////////////
// this function re-initializes the preference settings and activates them
////////////////////////////////////////////////////////////////////////////////
function reInitPrefs()
{
  // var os_AutohideTabs  = mvPrefs.HiddenTabs;
  var os_AutohideTabs  = mvPrefs.AutohideTabs;
  var os_StatusLeds    = mvPrefs.StatusLeds;
  var os_MaxStickyLen  = mvPrefs.MaxStickyLen;
  var os_TitleSticky   = mvPrefs.TitleSticky;
  var os_DevTooltips   = mvPrefs.DevTooltips;
  var os_MMClickNewTab = mvPrefs.MMClickNewTab;
  var classLabel       = null;
  var i                = 0;

  initPreferences();

  /////////////////////////////////////////////
	// hide or unhide the last active tab
  /////////////////////////////////////////////
  if ( os_AutohideTabs != readMyPref( "multizilla.tabs.autohide", "bool", false ) ) {
    mvPrefs.HiddenTabs ? true: false;
	  /* if ( os_AutohideTabs )
      mvPrefs.HiddenTabs = true;
    else
      mvPrefs.HiddenTabs = false; */
    if ( mvGlobal.TotalTabs == 0 )
      toggleTabs();
  }
ue: false;
///////////////////
// this function re-initializes the preference settings thdMyPref( "multizilla.sticky.maxlen", "int"ilntutohs p "multiideTabs != readMyPref( "multizilla.tabs.autohide", "bool",e );
  mvPrefs.  mvPrefs.HiddenTabs ? true: fal "multizilla.display.peTabs )
 ool",e );
  mvPrefs.his functswitchrefsTo('bottif')al.TotalTabs 		ctswitchrefsTo('mul')al.Totlizes the preference settings thdMyPref( "multizilla.sticky.
/////ckyLen  = rea LED////o/fromutohsideTabs != readMyPref( "multizilla.tabs.autohide", "bool", faefs.MaxStic!en;
  var os_TitleSeTabs )
 lse
   ;
  var os_TitleSeTabs )
 
 ool",e );
  mvPrefs.his funct eferences();= "tohutoh-gremul;is functlTabs == 0 ) eferences();= "toh-bottifutoh-gremul;is fun}l.TotalTababs )
 
 ool",e );
  mvPrefs.his funct eferences();= "tohl;is functlTabs == 0 ) eferences();= "toh-bottifl;is fun}l.Tota////(//////////<=///////////////////////++eTabs )
 
 true ////////abboxElemPrefchildNodes[///]eadtAtther exdenferendisferences();)al.Tota}
ue: false;
///
  var os_TitleSeTabs )
 
 ////(//////////<=///////////////////////++eTabs )
 
  ue ////////abboxElemPrefchildNodes[///]eadtAtther exdenmultiziplay";)al.Totaun}l.Tota}l.TotalTababs )
 
 ////(//////////<=///////////////////////++eTabs )
 
  ue ////////abboxElemPrefchildNodes[///]eckyLenAtther exdenmult;)al.Totaun}l.Tota}l.Tos the preference settings thdMyPref( "multizilla.sticky.maxlen",ohules();licky.t////text/dMy///foideTabs != readMyPref( "multizilla.tabs.autohide", "bool", faPrefs.TitleSt!cky;
  var os_DevToolrefsmvPrefs.DevTool!ps;
  var os_MMClickeTabs )
 ////(//////////<=//////////////////////++eTabs )
 
 e;
///////////abboxElemPrefchildNodes[///]egdtAtther exdenMyPrefnamy";)l!psiplay";)s == 0 ) efheckFor os_MOeTab
///////////abboxElemPrefchildNodes[///];)al.Tota}lizes the preference settings thdMyPref( "multizilla.sticky.maxlen", "iref( "muder the Lnt"ilntutohsideTabs != readMyPref( "multizilla.tabs.autohide", "bool", farefs.MMClick!wTab;
  var classLabeTabs )
 ////(//////////<=///////////////////////++eTabs )
 
 ferencclassLa
///////////abboxElemPrefchildNodes[///];)al.Tota}lizes the preference settings thdMyPref( "multizilla.sticky.maxlen", "is distr     =  erflo opolr////ideTabs != readMyPref( "multizilla.tabs.autohide", "bool", faPll;
  var i !               = 0;

eTabs )
 ool",e );
       = 0;

eTabs )
   /////.Hiddenlla.dis"    = erflo.opol0;
WindinSti
  }removetab.onovta}l.TotalTabs )
   /////.Hiddenlla.dis"    = erflo.opol0;
WindinStiplayremovetab.onovs the p TODO:tswitch  "mul/textressewPrefsAddedMyPref, oolmaxlen"ilr////-tabs.ontop-adv httd.xul///////////////////
// this function re-initializes the preference settings and activates them
/////////turnsiplayremovetar the Lvalunder the Lgs_Alr////////////////////////////
function reInitPrefs()
{
  // var os_AutohideTabs  = mvPrefs.HiddenTabs;
 refs.Hidde//////////////,e////TypyredefaabsS/tup tohideTa////////Valun/////////e );
///////= Componrsio.ferenes[/"@s distribute///////////;1" ]s == 0 ) eeeeeeeeeeeeeeegdtServicxdeComponrsio.interfa///.nsI);
Br hth mvPrefs.switch(e////Typy;)s == 0bs )
   caetanlla.d: s == 0 ) e{s == 0 ) eeetrye{s == 0 ) eee /////Valun         //////egdtBla..Hidde////////////// mv s == 0 ) eee}s == 0 ) eeecatch(eexeTabs )
 
  u eeetrye{s == 0 ) eee / /////Valun         //////egdtDefaabsBla..Hidde////////////// mvs == 0 ) eee /}s == 0 ) eee /catch(eexeTabs )
 
  u eee  /////.Hidde////Typyre//////////////,edefaabsS/tupisplay.ps )
 
  u eee  /////////////////////++;s )
 
  u eee  //turnl",defaabsS/tup tvs == 0 ) eee /}s == 0 ) eee}s == 0 ) eeeool",////Valun efs!////Valun ) s == 0 ) eee ///turnl",////Valun )vs == 0 ) eeelTaba//turnl",defaabsS/tup tvs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanload:s == 0 ) e{s == 0 ) eeetrye{s == 0 ) eee /////Valun         //////egdtInt.Hidde////////////// mvs == 0 ) eee}s == 0 ) eeecatch(eexeTabs )
 
  u eeetrye{s == 0 ) eee / /////Valun         //////egdtDefaabsInt.Hidde////////////// mvs == 0 ) eee /}s == 0 ) eee /catch(eexeTabs )
 
  u eee  /////.Hidde////Typyre//////////////,edefaabsS/tupisplay.ps )
 
  u eee  /////////////////////++;s )
 
  u eee  //turnl",defaabsS/tup tvs == 0 ) eee /}s == 0 ) eee}s == 0 ) eee//turnl",////Valun )vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanlla.mou:s == 0 ) e{s == 0 ) eeetrye{s == 0 ) eee /////Valun         //////egdtComplexValunde//////////////,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsISupportsWSla.mo mvs == 0 ) eee}s == 0 ) eeecatch(eexeTabs )
 
  u eeetrye{s == 0 ) eee / /////Valun         //////egdtDefaabsComplexValunde//////////////,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsISupportsWSla.mo mvs == 0 ) eee /}s == 0 ) eee /catch(eexeTabs )
 
  u eee  /////.Hidde////Typyre//////////////,edefaabsS/tupisplay.ps )
 
  u eee  /////////////////////++;s 							//turnl",defaabsS/tup tvs == 0 ) eee /}s == 0 ) eee}s == 0 ) eeeool",////Valun.rena.licky.tps )
 
  u eee//turnl",////Valun.rena )vs == 0 ) eeelTabs )
 
  u eee//turnl",defaabsS/tup tvs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanmaxru:s == 0 ) e{s == 0 ) eeetrye{s == 0 ) eee /////Valun         //////egdtCaxr.Hidde////////////// mvs == 0 ) eee}s == 0 ) eeecatch(eexeTabs )
 
  u eeetrye{s == 0 ) eee / /////Valun         //////egdtDefaabsCaxr.Hidde////////////// mvs == 0 ) eee /}s == 0 ) eee /catch(eexeTabs )
 
  u eee  /////.Hidde////Typyre//////////////,edefaabsS/tupisplay.ps )
 
  u eee  /////////////////////++;s )
 
  u eee  //turnl",defaabsS/tup tvs == 0 ) eee /}s == 0 ) eee}s 	 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanurlu:s == 0 ) e{s == 0 ) eeetrye{s == 0 ) eee /////Valun         //////egdtComplexValunde//////////////,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsI    "htt////dSla.mo mvs == 0 ) eee}s == 0 ) eeecatch(eexeTabs )
 
  u eeetrye{s == 0 ) eee / /////Valun         //////egdtDefaabsComplexValunde//////////////, s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsI    "htt////dSla.mo mvs == 0 ) eee /}s == 0 ) eee /catch(eexeTabs )
 
  u eee  /////.Hidde////Typyre//////////////,edefaabsS/tupisplay.ps )
 
  u eee  /////////////////////++;s )
 
  u eee  //turnl",defaabsS/tup tvs == 0 ) eee /}s == 0 ) eee}s == 0 ) eeeool",////Valun.rena.licky.tps )
 
  u eee//turnl",////Valun.rena )vs == 0 ) eeelTabs )
 
  u eee//turnl",defaabsS/tup tvs 					b
 rkvs == 0 ) e}s )
   defaabs:s == 0 ) e{s == 0 ) eeeky.
Prefs.wrongP///TypyUode )vs == 0 ) e}s )
 }s )
//turnl",////Valun )vs /////////////////
// this function re-initializes the preference settings and activates them
////////////the Lgs_Alr///////////typyre////////////////
function reInitPrefs()
{
  // var os_AutohideTabs  = mvPrefs.HiddenTabs;
/////.Hidde////Typyre////Sla.mo,,////Valun,,////DefaabsFlag tohideTa////e );
///////= Componrsio.ferenes[/"@s distribute///////////;1" ]s == 0 ) eeeeeeeeeeeeeeegdtServicxdeComponrsio.interfa///.nsI);
Br hth mvPrefs.trye{s == 0switch (e////Typy;)0bs )
   caetanlla.d:s == 0 ) e{s == 0 ) eee////DefaabsFlag ?       //////esdtBla..Hidde////Sla.mo,,////Valun;)0:       //////esdtDefaabsBla..Hidde////Sla.mo,,////Valun;)vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanload:s == 0 ) e{s == 0 ) eee////DefaabsFlag ?       //////esdtInt.Hidde////Sla.mo,,////Valun;)0:       //////esdtDefaabsInt.Hidde////Sla.mo,,////Valun;)vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanlla.mou:s == 0 ) e{s == 0 ) eee////lla/= Componrsio.ferenes[/"@s distributesupports-wlla.mo;1" ] s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee.enk-JoInst htt(Componrsio.interfa///.nsISupportsWSla.mo)vs == 0 ) eeella.rena =/////Valun///// 0 ) eee////DefaabsFlag ?       //////esdtComplexValunde////Sla.mo,,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsISupportsWSla.mo,,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeella/)0: s == 0 ) eeeeeeeeeeeeeeeeeeeee      //////esdtDefaabsComplexValunde////Sla.mo,,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsISupportsWSla.mo,,s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeella/)vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanurlu:s == 0 ) e{s == 0 ) eee////DefaabsFlag ?       //////esdtComplexValunde//////////////, s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsI    "htt////dSla.mo, s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee////Valun;)0: s == 0 ) eeeeeeeeeeeeeeeeeeeee      //////esdtDefaabsComplexValunde//////////////, s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeComponrsio.interfa///.nsI    "htt////dSla.mo, s == 0 ) eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee////Valun;)vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   caetanmaxru:s == 0 ) e{s == 0 ) eee////DefaabsFlag ?        //////esdtCaxr.Hidde////Sla.mo,,////Valun;)0:       //////esdtDefaabsCaxr.Hidde////Sla.mo,,////Valun;)vs == 0 ) eeeb
 rkvs == 0 ) e}s )
   defaabs:s == 0 ) e{s == 0 ) eeeky.
Prefs.wrongP///TypyUode )vs == 0 ) e}s )
 }s )
}s )
catch (eexeTabeky.die silictlytlizes t/////////////////
// this function re-initializes the preference settings and activates them
///////adds a sm2001lla.mo may notuseraglntuto i//////y///////////////////////////
function initPreferences()
{
  // moved to initTabPosition() in multiview///////////////ohideTa////i/////////  mvPrefs.Hidd"glneral.useraglnt.misctizilla.mouse-middledeTaool",i/////////esdarch(e"mz:";)l== -1tps )
 /////.Hiddenlla.mouse-glneral.useraglnt.misctizi///////// + "; " added)');
UodrAglntonfirm.quit/////////////////
// this function re-initializes the preference settings and activates them
///////adds a sm2001lla.mo may notuseraglntuto i//////y///////////////////////////
function initPreferences()
{
  // moved to initTabPosition() in multiviewckyLen////////////ohideTa////i/////////  mvPrefs.Hidd"glneral.useraglnt.misctizilla.mouse-middletli	ool",i/////////esdarch(e"mz:";)l!= -1tpe{s == 0////llartPos();i/////////esdarch(e"rv:";)s == 0i/////////  mi/////////esublla(/llartPos,/llartPos(+mi/////////ella.sOdden;";)l)vs == 0/////.Hidd